#include<GuiConstantsEx.au3>
#include<WindowsConstants.au3>
#include<GuiTreeView.au3>
#include<ShellTristateTreeView.au3>
#include<Array.au3>
#include<WinAPI.au3>

;===============================================================================
;
; Program Name:   	ShellTristateTreeViewDemo.au3
;					Userfunction My-WM_Notify() is registered in ShellTristateTreeView.au3.
;
;					AutoIt Version: 3.2.12.1
;
; Author(s):        Rasim (ShellTreeView.au3)
;					Holger Kotsch (TristateTreeViewLib.au3)
;           		Merged & Modified by Polyphem
;					Ported to Au native filesearch and further enhancements by KaFu
;
; Note(s):
;   2008-Sep-15    	Modified by KaFu from original functions
;===============================================================================

Global $sStateIconFile = @ScriptDir & "\modern.bmp"
Global $aTreeViewItemState[1][1],$aTreeViewItemStateChecked[1][1]

$hGUI = GUICreate("ShellTristateTreeView Demo", 300, 340)
$ButtonSelected = GUICtrlCreateButton("Selected Item", 10, 300, 80, 23)
$ButtonCheckedStats = GUICtrlCreateButton("Checked Status", 110, 300, 80, 23)
$ButtonCheckedFull = GUICtrlCreateButton("Checked Full", 210, 300, 80, 23)
$hTreeView = _GUICtrlTreeView_Create($hGUI, 20, 20, 260, 260, BitOR($TVS_HASBUTTONS, $TVS_HASLINES, $TVS_LINESATROOT,$TVS_DISABLEDRAGDROP, $TVS_CHECKBOXES),$WS_EX_CLIENTEDGE)
_GUICtrlTreeView_BeginUpdate($hTreeView)
_ShellTreeView_Create($hTreeView)
_GUICtrlTreeView_SetState($hTreeView, _GUICtrlTreeView_GetFirstItem($hTreeView),$TVIS_EXPANDED,true)
_ShellTreeView_GetSelected($hTreeView, _GUICtrlTreeView_GetText($hTreeView, _GUICtrlTreeView_GetFirstItem($hTreeView)),  _GUICtrlTreeView_GetFirstItem($hTreeView))
_GUICtrlTreeView_EndUpdate($hTreeView)

GUISetState()
LoadStateImage($hTreeView, $sStateIconFile)

While 1
    $msg = GUIGetMsg()
    Switch $msg
        Case $GUI_EVENT_CLOSE
            Exit

        Case $ButtonSelected
            $hSelect = _GUICtrlTreeView_GetSelection($hTreeView)
            If $hSelect Then
                $sText = _GUICtrlTreeView_GetText($hTreeView, $hSelect)
                MsgBox(64, "ShellTristateTreeViewDemo - Info", _ShellTreeView_GetSelected($hTreeView, $sText, $hSelect, true))
            EndIf

		Case $ButtonCheckedStats
			GUISetState(@SW_LOCK)
			$iCountState = 0
			redim $aTreeViewItemState[_GUICtrlTreeView_GetCount($hTreeView)][2]
			$hItem = _GUICtrlTreeView_GetFirstItem($hTreeView)
			while $hItem
				if $iCountState = 0 Then
					$aTreeViewItemState[$iCountState][0] = "My Computer"
				Else
					$sText = _GUICtrlTreeView_GetText($hTreeView, $hItem)
					$aTreeViewItemState[$iCountState][0] = _ShellTreeView_GetSelected($hTreeView, $sText, $hItem, true)
				EndIf
				$aTreeViewItemState[$iCountState][1] = MyCtrlGetItemState($hTreeView,$hItem)
				$iCountState += 1
				$hItem = _GUICtrlTreeView_GetNext($hTreeView, $hItem)
			WEnd
			GUISetState(@SW_UNLOCK)
			_ArrayDisplay($aTreeViewItemState)


		Case $ButtonCheckedFull
			GUISetState(@SW_LOCK)
			$aTreeViewItemState = ""
			dim $aTreeViewItemState[_GUICtrlTreeView_GetCount($hTreeView)][2]
			$hItemRoot = _GUICtrlTreeView_GetFirstItem($hTreeView)
			$aTreeViewItemState[0][0] = "My Computer"
			$aTreeViewItemState[0][1] = MyCtrlGetItemState($hTreeView,$hItemRoot)
			$iCountStateChecked = 1
			if MyCtrlGetItemState($hTreeView, $hItemRoot) = 1 Then ; if "My Computer" is activated
				$hItemSub = _GUICtrlTreeView_GetFirstChild($hTreeView, $hItemRoot)
				While $hItemSub
					$iCountStateChecked += 1
					$sText = _GUICtrlTreeView_GetText($hTreeView, $hItemSub)
					$aTreeViewItemState[$iCountStateChecked][0] = _ShellTreeView_GetSelected($hTreeView, $sText, $hItemSub, true)
					$aTreeViewItemState[$iCountStateChecked][1] = MyCtrlGetItemState($hTreeView,$hItemSub)
					$hItemSub = _GUICtrlTreeView_GetNextChild($hTreeView, $hItemSub)
				WEnd
			ElseIf MyCtrlGetItemState($hTreeView, $hItemRoot) = 2 Then  ; if anything else is activated
				_TreeviewGetChildState($hTreeView, $hItemRoot, $iCountStateChecked)
			EndIf

			; Parse and clean the results, just keep top-most parent directories activated and skip childs
			_ArrayDelete($aTreeViewItemState,0)
			_ArraySort($aTreeViewItemState,1)
			for $iCountStateChecked = ubound($aTreeViewItemState)-1 to 1 step -1
				if stringlen($aTreeViewItemState[$iCountStateChecked][0]) = 0 then _ArrayDelete($aTreeViewItemState,$iCountStateChecked)
			Next
			_ArraySort($aTreeViewItemState)
			for $i = 0 to UBound($aTreeViewItemState)-2
				if $i = UBound($aTreeViewItemState) - 1 then ExitLoop
				if StringInStr($aTreeViewItemState[$i+1][0],$aTreeViewItemState[$i][0]) then
					_ArrayDelete($aTreeViewItemState,$i+1)
					$i = $i -1
				endif
			Next
			GUISetState(@SW_UNLOCK)
			if stringlen($aTreeViewItemState[0][0]) = 0 then
				MsgBox(64,"ShellTristateTreeView Demo","Nothing selected...")
			Else
				_ArrayDisplay($aTreeViewItemState)
			endif
    EndSwitch
WEnd



Func _TreeviewGetChildState($hTreeView, $hItem, $iCountStateChecked)
	Local $hItemSub

	$hItemSub = _GUICtrlTreeView_GetFirstChild($hTreeView, $hItem)
	While $hItemSub
		if MyCtrlGetItemState($hTreeView, $hItemSub) = 2 Then
			$iCountStateChecked = _TreeviewGetChildState($hTreeView, $hItemSub, $iCountStateChecked)
		ElseIf MyCtrlGetItemState($hTreeView, $hItemSub) = 1 Then
			$iCountStateChecked += 1
			$sText = _GUICtrlTreeView_GetText($hTreeView, $hItemSub)
			$aTreeViewItemState[$iCountStateChecked][0] = _ShellTreeView_GetSelected($hTreeView, $sText, $hItemSub, true)
			$aTreeViewItemState[$iCountStateChecked][1] = MyCtrlGetItemState($hTreeView,$hItemSub)
		endif
		$hItemSub = _GUICtrlTreeView_GetNextChild($hTreeView, $hItemSub)
	WEnd
	Return $iCountStateChecked

EndFunc